<?php
/**
 * 原单反算：和公司出去的业务有关（SalesOrder,ServiceContracts,Invoice,OutBoundOrder);
 * 
 * */
class cls_OutSale_InverseCompute
{
    /**
     * module:操作按钮所操作的模块,例如保存出库单,那么module=OutBound
     * id：操作按钮操作数据的Id
     * */
    public static function InverseCompute($module,$id,$focus='')
    {
        global $adb;
        $focus=CRMEntity::getInstance($module);
        $detailtable=$focus->Detail_table;
        
        switch($module)
        {
             case 'SalesBack'://销售退货
                $sql="select salesbackstatus,quantity,parent_lineitem_id,entitytypeid from ld_salesback 
	                   	inner join $detailtable on $detailtable.id=ld_salesback.salesbackid where salesbackid =? ";
               	$results=$adb->pquery($sql,array($id));
              
                $num_rows=$adb->num_rows($results);
                for ($i = 0; $i < $num_rows; $i++) { 
                 
                    $qty = $adb->query_result($results,$i,'quantity');
                    $entitytypeid = $adb->query_result($results,$i,'entitytypeid');
                    $parent_lineitem_id = $adb->query_result($results,$i,'parent_lineitem_id');
                    $salesbackstatus=$adb->query_result($results,$i,'salesbackstatus');
                    //反写合同订单已出库和未出库数量
                    if($salesbackstatus==SALESBACKINSTOCK)//已入库
                        self::updateSalesOrder_BySalesBackBack(0,$qty,$entitytypeid,$parent_lineitem_id);
                    else if($salesbackstatus == SALESBACKOUTSTOCK)
                        self::updateSalesOrder_BySalesBackBack($qty,0,$entitytypeid,$parent_lineitem_id);
                }
               break;
               
            case 'OutboundOrder':
                 $sql="select entitytypeid ,entitytype from $detailtable where id=? and entitytypeid>0 group by entitytypeid";
                $result=$adb->pquery($sql,array($id));
                $num_rows=$adb->num_rows($result);
              
                for($i=0;$i<$num_rows;$i++)
                {
                    $entitytypeid=$adb->query_result($result,$i,'entitytypeid');
                    $entitytype=$adb->query_result($result,$i,'entitytype');
                    $entityids[$entitytypeid]=$entitytype;
                   
                }
              
                if(is_array($focus->before_sourcemodule_info)&&sizeof($focus->before_sourcemodule_info)>0)
                {
                    foreach($focus->before_sourcemodule_info as $index =>$datainfo)
                    {
                         $entityids[$datainfo['entitytypeid']]=$datainfo['entitytype'];
                    }
                }
                foreach($entityids as $entitytypeid=>$entitytype)
                {
                     cls_Source_InverseCompute::updateoutboundEntityInfo($entitytypeid,$entitytype);//更新源单出库状态和已出库和未数量
                }
                self::updateInvoiceCount($id,$module);//更新出库单已开票和未开票数量
               //更新已开票金额
                 self::updateInvoiceMoney($id,'OutboundOrder');
                break;
            case 'Invoice':
                cls_Source_InverseCompute::updateoutboundEntityInfo($id,$module);//更新发票的出库状态和已出库和未出库数量
                $sql="select entitytypeid ,entitytype from $detailtable where id=? and entitytypeid>0 group by entitytypeid ";
                $result=$adb->pquery($sql,array($id));
                $num_rows=$adb->num_rows($result);
                for($i=0;$i<$num_rows;$i++)
                {
                     $entitytypeid=$adb->query_result($result,$i,'entitytypeid');
                    $entitytype=$adb->query_result($result,$i,'entitytype');
                    $entityids[$entitytypeid]=$entitytype;
                }
                if(is_array($focus->before_sourcemodule_info)&&sizeof($focus->before_sourcemodule_info)>0)
                {
                    foreach($focus->before_sourcemodule_info as $index =>$datainfo)
                    {
						if(!empty($datainfo['entitytypeid']))
							$entityids[$datainfo['entitytypeid']]=$datainfo['entitytype'];
                    }
                }
               
                foreach( $entityids as $entitytypeid=>$entitytype )
                {
                    self::updateInvoiceCount($entitytypeid,$entitytype);//更新发票的源单已开票和未开票数量
                    self::updateInvoiceMoney($entitytypeid,$entitytype);
                }
              //die;
                break;
            case 'ServiceContracts':
                 cls_Source_InverseCompute::updateoutboundEntityInfo($id,$module);//更新服务合同的出库状态和已出库和未出库数量
                 //更新服务合同已开发票和未开发票数量
                 self::updateInvoiceCount($id,$module);
				  self::updateServiceContracts_purchasestatus($id);
                  //更新已开票金额
                 self::updateInvoiceMoney($id,'ServiceContracts');
                break;
           case "Quotes":
                 //更新报价单的已下单和未下单数量
                  
                self::updateOrderCount($id,'Quotes');
         
                break;
            case 'SalesOrder':
                	cls_Source_InverseCompute::updateoutboundEntityInfo($id,$module);
                   
               //更新合同订单已开发票和未开发票数量
                 self::updateInvoiceCount($id,$module);
                 
                 self::updateSalesOrder_purchasestatus($id);//修改合同订单的采购状态
                
                 //更新已开票金额
                 self::updateInvoiceMoney($id,'SalesOrder');
                 
                  $sql="select entitytypeid ,entitytype from $detailtable where id=? and entitytypeid>0 group by entitytypeid ";
                $result=$adb->pquery($sql,array($id));
                $num_rows=$adb->num_rows($result);
                for($i=0;$i<$num_rows;$i++)
                {
                     $entitytypeid=$adb->query_result($result,$i,'entitytypeid');
                    $entitytype=$adb->query_result($result,$i,'entitytype');
                    if(!array_key_exists($entitytypeid,$entityids))
                    {
                        $entityids[$entitytypeid]=$entitytype;
                        //更新报价单的已下单和未下单数量
                        self::updateOrderCount($entitytypeid,$entitytype);
                    }
                    
                }
                 
                
                break;
        }
    }
    
    
    
     
       /**
     * 销售退货单改变合同订单已出库数量和未出库数量
     * 
     * */
    private static function updateSalesOrder_BySalesBackBack($qty,$beforeqty,$entitytypeid,$parent_lineitem_id)
    {
         global $adb;
       //  echo $entitytypeid.'asss';
        // dump($parent_lineitem_id);
         //已出库数量 = 合同订单的已出库数量+当前界面产品的出库数-当前产品数据库中对应已出库数
            $adb->pquery(" update ld_salesorderdetail set haveoutproductcount = haveoutproductcount + ? - ?
            where id = ? and lineitem_id = ?",array($qty,$beforeqty,$entitytypeid,$parent_lineitem_id));
            
           
         
            //print_r(array($qty,$beforeqty,$entitytypeid,$parent_lineitem_id));
            //未出库数量 = 合同订单产品数量 - 合同订单已出库数量
            $adb->pquery("update ld_salesorderdetail set balanceoutproductcount = quantity - haveoutproductcount 
            where id = ? and lineitem_id = ?",array($entitytypeid,$parent_lineitem_id));
            //dump(array($entitytypeid,$parent_lineitem_id));
            
    }
     
     
     /**
     反写合同订单采购状态，已采购和未采购数量
     **/
    public static function updateSalesOrder_purchasestatus($salesorder_id)
     {
         global $adb;
    	if(!empty($salesorder_id))
        {
                		$source_focus=CRMEntity::getInstance("SalesOrder");
                        $sourcedetail_table=$source_focus->Detail_table;
                        
                		//更新未采购
                		$sql=" select quantity-ifnull(tmp.havequantity,0) as tmpbalance,lineitem_id  from  $sourcedetail_table 
                				LEFT  join(
                						SELECT
                							sum(quantity) AS havequantity,
                							parent_lineitem_id,
                							productid,ld_purchaseorderdetail.entitytypeid
                						FROM  ld_purchaseorderdetail
                						INNER JOIN ld_purchaseorder ON ld_purchaseorderdetail.id=ld_purchaseorder.purchaseorderid
                						WHERE 	ld_purchaseorder.DELETEd = 0";
                	
                		$sql.="  GROUP BY ld_purchaseorderdetail.entitytypeid,parent_lineitem_id,
                                            	productid ) as tmp  
                                        on $sourcedetail_table.lineitem_id=tmp.parent_lineitem_id 
                                       and $sourcedetail_table.id=tmp.entitytypeid
                                        where id =?";     
                         $sql=" update $sourcedetail_table inner join  ( ".$sql." ) as tmp  on tmp.lineitem_id=$sourcedetail_table.lineitem_id set balancepurchasecount=tmpbalance ";
                  
                		$adb->pquery($sql,array($salesorder_id)) ;
                		//已采购数量
                		$sql= "update $sourcedetail_table set havepurchasecount=quantity-balancepurchasecount 
                		where id=?;";
                		$adb->pquery($sql,array($salesorder_id));
                        
                		//获取采购订单的总数量和总已购数量
                	 $query = "select sum(ifnull(havepurchasecount,0)) as havepurchasecount,sum(ifnull(balancepurchasecount,0)) as balancepurchasecount
                     from $sourcedetail_table where id = ? group by id";
                    $numresult = $adb->pquery($query,array($salesorder_id));
                    $havepurchasecount = $adb->query_result($numresult,0,'havepurchasecount');
                    $balancepurchasecount = $adb->query_result($numresult,0,'balancepurchasecount');
                    if($havepurchasecount >0 && $balancepurchasecount>0)
                        $purchaseStatus = PARTPURCHASE;
                    elseif($havepurchasecount >0 && $balancepurchasecount <=0)
                        $purchaseStatus = ALLPURCHASE;
                    elseif($havepurchasecount <=0 && $balancepurchasecount >0)
                        $purchaseStatus = NOPURCHASE;
                    $adb->pquery("update ld_salesorder set purchasestatus = '".$purchaseStatus."' where salesorderid = $salesorder_id");
    	}
     }

	  /**
     反写服务合同，已采购和未采购数量
     **/
    public static function updateServiceContracts_purchasestatus($servicecontractsid)
     {
         global $adb;
    	if(!empty($servicecontractsid))
        {
                        $source_focus=CRMEntity::getInstance("ServiceContracts");
                        $sourcedetail_table=$source_focus->Detail_table;
                		
                		//更新未采购
                		$sql=" select quantity-ifnull(tmp.havequantity,0) as tmpbalance,lineitem_id  from  $sourcedetail_table 
                				LEFT  join(
                						SELECT
                							sum(quantity) AS havequantity,
                							parent_lineitem_id,
                							productid
                						FROM  ld_purchaseorderdetail
                						INNER JOIN ld_purchaseorder ON ld_purchaseorderdetail.id=ld_purchaseorder.purchaseorderid
                						WHERE 	ld_purchaseorder.DELETEd = 0";
                	
                		$sql.="  GROUP BY parent_lineitem_id,
                                            	productid ) as tmp  
                                        on $sourcedetail_table.lineitem_id=tmp.parent_lineitem_id 
                                       
                                        where id =?";     
                         $sql=" update $sourcedetail_table inner join  (  ".$sql." ) as tmp  on tmp.lineitem_id=$sourcedetail_table.lineitem_id set balancepurchasecount=tmpbalance ";
                  
                		$adb->pquery($sql,array($servicecontractsid)) ;
                		//已采购数量
                		$sql= "update $sourcedetail_table set havepurchasecount=quantity-balancepurchasecount 
                		where id=?;";
                		$adb->pquery($sql,array($servicecontractsid));
    	}
     }
	 //更新源单的已出库金额、未出库金额、已出库数量、未出库数量，最新出库日期
	 public static function updateSourceModuleOutboundAmount($entitytypeid,$module){
		global $adb;
		if($module == 'SalesOrder' || $module == 'ServiceContracts'){
			$focus=CRMEntity::getInstance($module);
			$Detail_table = $focus->Detail_table;
            $tablename=$focus->table_name;
             $Detail_table=$focus->Detail_table;
             $table_index=$focus->table_index;
             $sql="update $tablename inner join (select sum(ifnull($Detail_table.haveoutproductcount,0)) as sumhaveoutcount
                    		,sum(ifnull($Detail_table.balanceoutproductcount,0)) as sumbalancecount,id from ld_salesorderdetail
                    GROUP BY id) as tmp 
                    on $tablename.$table_index=tmp.id
                    set $tablename.haveoutboundcount=tmp.sumhaveoutcount,$tablename.balanceoutboundcount=sumbalancecount
                    where $tablename.$table_index=?;";
                   
             $adb->pquery($sql,array($entitytypeid));
            
			$entity_sql='select currency_id,conversion_rate ,total,sum(quantity) as qty from  '.$focus->table_name.' LEFT JOIN '.$Detail_table.' on '.$Detail_table.'.id = '.$focus->table_name.'.'.$focus->table_index.'  where '.$focus->table_index.'=?';
			$result=$adb->pquery($entity_sql,array($entitytypeid));
			$entity_total=$adb->query_result($result,0,'total');
			$entity_currency_id=$adb->query_result($result,0,'currency_id');
			$entity_conversion_rate=$adb->query_result($result,0,'conversion_rate');
			$all_quantity=$adb->query_result($result,0,'qty');
			crm_load_class_file('cls_Common_Sql','include/utils');
			$sql=cls_Common_Sql::startSameCurrecnyId_ouboundSql();//有调整，则该sql计算的数量有错误
            
			$result=$adb->pquery($sql,array($entitytypeid));
			if($adb->num_rows($result)>0)
			{
				$have_outbound_amount=$adb->query_result($result,0,'sum_amount');
				$have_outbound_quantity = $adb->query_result($result,0,'sum_quantity');
				if(empty($have_outbound_quantity))$have_outbound_quantity = 0;
				if(empty($have_outbound_amount))
				{
					$sql=' update '.$focus->table_name.' set haveoutboundamount=? ,balanceoutboundamount=total,lastoutbounddate=? where  '.$focus->table_index.'=?';
					   
					 $adb->pquery($sql,array(0,'',$entitytypeid));
					 return false;
				}
				
				$outdate=$adb->query_result($result,0,'outdate');
			   
			}
			else
			{
				$have_outbound_amount=0;
				$outdate='';
				$have_outbound_quantity=0;
				
			}
			if($entity_currency_id != 1)
			{
				$currencyobj=new Currency($adb,1);
				$entity_currencyobj=new Currency($adb,$entity_currency_id);
				$entity_currencyobj->setCurrencyRate($entity_conversion_rate);
				$have_outbound_amount=$entity_currencyobj->ConvertTothisobj_money($currencyobj,$have_outbound_amount);
			}
		
			 $sql=' update '.$focus->table_name.' set haveoutboundamount=? ,balanceoutboundamount=total-? ,lastoutbounddate=? where  '.$focus->table_index.'=?';
		
			 $adb->pquery($sql,array($have_outbound_amount,$have_outbound_amount,$outdate,$entitytypeid));
             
		}
	 }

     public static function updateInvoiceMoney($entitytypeid,$module)
     {
 
        global $adb;
        
          $focus=CRMEntity::getInstance($module);
          $entity_sql='select currency_id,conversion_rate ,total from  '.$focus->table_name.' where '.$focus->table_index.'=?';
        $result=$adb->pquery($entity_sql,array($entitytypeid));

        $entity_total=$adb->query_result($result,0,'total');
        $entity_currency_id=$adb->query_result($result,0,'currency_id');
        $entity_conversion_rate=$adb->query_result($result,0,'conversion_rate');
        
        crm_load_class_file('cls_Common_Sql','include/utils');
     $sql=" select DISTINCT ld_invoice.currency_id from ld_invoicedetail
                INNER JOIN ld_invoice on ld_invoice.invoiceid=ld_invoicedetail.id
                 where ld_invoice.deleted=0 and  entitytypeid=? ";
     $result=$adb->pquery($sql,array($entitytypeid));
     $invoice_currency_id=$adb->query_result($result,0,0);
     $numrows=$adb->num_rows($result);
     if($numrows>1||$entity_currency_id!=$invoice_currency_id)
      {
        //源单的发票币种不一样或源单币种和发票币种不一样
         $sql=cls_Common_Sql::startinvoiceSql($entitytypeid);
        
      }   
      else 
      {
        
        $sql=cls_Common_Sql::startSameCurrecnyId_invoiceSql($entitytypeid);
      }
        $sql.= ' and  c.entitytypeid='.$entitytypeid;
        $sql.=cls_Common_Sql::endinvoiceSql();     
     
        $result=$adb->pquery($sql,array());
      
        if($adb->num_rows($result)>0)
        {
            $have_invoicetotal=$adb->query_result($result,0,'invoicetotal');
          
          if(empty($have_invoicetotal))
            {
                $sql=' update '.$focus->table_name.' set lastinvoice_no=?,have_invoicetotal=? ,nothave_invoicetotal=total,lastinvoicedate=? where  '.$focus->table_index.'=?';
                   
                 $adb->pquery($sql,array('',0,'',$entitytypeid));
                 return false;
            }
            
            $invoicedate=$adb->query_result($result,0,'invoicedate');
          
            $invoice_num=$adb->query_result($result,0,'invoice_num');
           
        }
        else
        {
            $have_invoicetotal=0;
            $invoicedate='';
            $invoice_num='';
            
        }
     //echo $numrows."aa".$entity_currency_id.'bb'.$invoice_currency_id;
     //$numrows>1:代表发票有多个币种
        if( $numrows>1||$entity_currency_id<>$invoice_currency_id)
        {
            //37744: （1.6）新增一条币种为外币的采购订单>采购订单相关创建采购发票：创建采购发票后，采购订单的已开票金额显示负数。（需要补丁）
            $currencyobj=new Currency($adb,1);
           
            $entity_currencyobj=new Currency($adb,$entity_currency_id);
            $entity_currencyobj->setCurrencyRate($entity_conversion_rate);
             
            $have_invoicetotal=$entity_currencyobj->ConvertTothisobj_money($currencyobj,$have_invoicetotal);
            
        }
       
        else
        {
            
           //echo $have_invoicetotal;
        }
     
  
         $sql=' update '.$focus->table_name.' set lastinvoice_no=?,have_invoicetotal=? ,nothave_invoicetotal=total-? ,lastinvoicedate=? where  '.$focus->table_index.'=?';
    
         $adb->pquery($sql,array($invoice_num,$have_invoicetotal,$have_invoicetotal,$invoicedate,$entitytypeid));
         
        
        
     }
      //销售发票 - 反写合同订单，服务合同出库单的已开票和未开票数量
       public static  function updateInvoiceCount($order_id,$module){
        global $adb;
        if(!empty($order_id)){
            $focus = CRMEntity::getInstance($module);
            $sourcedetail_table=$focus->Detail_table;
            
            //更新未开票
            $sql="  
				SELECT
    							($sourcedetail_table.quantity - ifnull(sum(ifnull(tmp_invoice.quantity,0)),0)) AS tmpbalance,
    							$sourcedetail_table.lineitem_id,
    							tmp_invoice.productid
    						FROM $sourcedetail_table 
                           
    						left  JOIN (select parent_lineitem_id,sum(quantity) as quantity,productid from  ld_invoice INNER JOIN ld_invoicedetail 
                                    on ld_invoicedetail.id=ld_invoice.invoiceid
                                    where deleted=0 and ld_invoicedetail.entitytype='".$module."' AND ifnull(ld_invoice.approvestatus,'' )<> '".D_A_S_REJECTED."'
                                    group by ld_invoicedetail.entitytypeid,ld_invoicedetail.parent_lineitem_id,ld_invoicedetail.productid) as tmp_invoice
                                    on tmp_invoice.parent_lineitem_id=$sourcedetail_table.lineitem_id
    						WHERE 	  $sourcedetail_table.id=? ";
            $sql.="  group by $sourcedetail_table.lineitem_id,$sourcedetail_table.productid ";
      
            $sql=" update $sourcedetail_table inner join  ( ".$sql." ) as tmp  on tmp.lineitem_id=$sourcedetail_table.lineitem_id set balanceinvoicecount=tmpbalance ";
       
            $adb->pquery($sql,array($order_id)) ;
      
            
    		// 已开票数量
    		$sql= "update $sourcedetail_table set haveinvoicecount=quantity-balanceinvoicecount 
    		where id=?;";
    		$adb->pquery($sql,array($order_id));
        }
     }
     //合同订单计算报价单的已下单和未下单数量
     //$sourceid：原单id
     public static function updateOrderCount($sourceid,$module){
        
        global $adb;
        if(!empty($sourceid))
        {
             $focus = CRMEntity::getInstance($module);
            $sourcedetail_table=$focus->Detail_table;
            $table_name=$focus->table_name;
            $table_index=$focus->table_index;
            
             $VersionInfo = getVersionInfo();
        
            if($VersionInfo['account'] == 'haige')
            {
                $sql='select potentialid from ld_quotes where quoteid=?';
                
                $sql="update ld_quotesdetail
                        INNER JOIN (
                        			select quoteid,ld_quotes.potentialid,deleted from ld_quotes inner join (
                        				select potentialid from ld_quotes 
                        				where ld_quotes.quoteid=?) tmpone
                        				 on tmpone.potentialid=ld_quotes.potentialid
                        				and ld_quotes.deleted=0
                        				order  by cast(quote_version as SIGNED INTEGER)  desc limit 1
                        ) as tmpone on tmpone.quoteid=ld_quotesdetail.id
                         INNER JOIN (
                        
                        select sum(ifnull(ld_salesorderdetail.quantity,0)) as sumordercount,tmp.potentialid
									,ld_salesorderdetail.productid
                        from ld_quotes
                        inner join (
                        select potentialid from ld_quotes 
                        where ld_quotes.quoteid=?) as tmp on tmp.potentialid=ld_quotes.potentialid and ld_quotes.deleted=0
                        INNER JOIN ld_salesorderdetail on ld_salesorderdetail.entitytypeid=ld_quotes.quoteid
                        inner join ld_salesorder on ld_salesorder.salesorderid=ld_salesorderdetail.id and 
                        ld_salesorder.deleted=0  group by tmp.potentialid,ld_salesorderdetail.productid
                        ) as tmptwo on tmptwo.potentialid=tmpone.potentialid and ld_quotesdetail.productid=tmptwo.productid
                          and  tmpone.deleted=0
                        set ld_quotesdetail.haveordercount=ifnull(sumordercount,0),
                        ld_quotesdetail.balanceordercount=ld_quotesdetail.quantity-ifnull(sumordercount,0)";
                $adb->pquery($sql,array($sourceid,$sourceid));
              
                
                $sql="update ld_quotes INNER JOIN 
                                (
                                			select quoteid,ld_quotes.potentialid,deleted from ld_quotes inner join (
                                				select potentialid from ld_quotes 
                                				where ld_quotes.quoteid=?) tmpone
                                				 on tmpone.potentialid=ld_quotes.potentialid
                                				and ld_quotes.deleted=0
                                				order  by cast(quote_version as SIGNED INTEGER)  desc limit 1
                                )  as tmpone on tmpone.quoteid=ld_quotes.quoteid
                                
                                 inner join (
                                        	select sum(tax_amount) as allordertotal,ifnull(ld_salesorder.currency_id,1),tmptwo.potentialid  from ld_quotes INNER JOIN
                                        	(
                                        													select potentialid from ld_quotes 
                                        													where ld_quotes.quoteid=?
                                        	) as tmptwo
                                           on tmptwo.potentialid=ld_quotes.potentialid
                                           inner join  ld_salesorderdetail on ld_salesorderdetail.entitytypeid=ld_quotes.quoteid
                                            inner join ld_salesorder on ld_salesorder.salesorderid=ld_salesorderdetail.id
                                            )as tmpthree on tmpthree.potentialid=tmpone.potentialid
                                
                                set  ld_quotes.hadorder_total=allordertotal";
                      $adb->pquery($sql,array($sourceid,$sourceid));          
                
            }
            else
            {
                $sql="update $sourcedetail_table LEFT JOIN (
                    select sum(quantity) as haveoutordercount,ld_salesorderdetail.entitytype,entitytypeid,parent_lineitem_id from ld_salesorderdetail
                    inner join ld_salesorder on ld_salesorder.salesorderid=ld_salesorderdetail.id
                     
                    where ld_salesorderdetail.entitytype=? and entitytypeid=? and ld_salesorder.deleted=0
                    GROUP BY ld_salesorderdetail.entitytype,entitytypeid,parent_lineitem_id ) as 
                    tmp on tmp.entitytypeid=$sourcedetail_table.id and $sourcedetail_table.lineitem_id=tmp.parent_lineitem_id
                    set $sourcedetail_table.haveordercount=ifnull(tmp.haveoutordercount,0)
                    where $sourcedetail_table.id=?;";
                $adb->pquery($sql,array($module,$sourceid,$sourceid));
                //dump(array($module,$sourceid));
                //exit();
                $sql="update $sourcedetail_table set balanceordercount=quantity-haveordercount
                where id=?;";
                $adb->pquery($sql,array($sourceid));
                //已下订单总额
                $sql=" update $table_name 
                         inner join ( select sum(tax_amount) as allordertotal,entitytype,entitytypeid,ifnull(ld_salesorder.currency_id,1) as currency_id  from ld_salesorderdetail
                            inner join ld_salesorder on ld_salesorder.salesorderid=ld_salesorderdetail.id
                             
                            where entitytype=? and entitytypeid=? and ld_salesorder.deleted=0
                            GROUP BY entitytype,entitytypeid ) as tmp
                            on tmp.entitytypeid=$table_name.$table_index
                       set $table_name.hadorder_total=case when ($table_name.currency_id=tmp.currency_id) then  tmp.allordertotal 
            						else (tmp.allordertotal*(tmp.currency_id/1))*IFNULL($table_name.currency_id ,1) 
            					end 
                        where $table_index=? ";
                $adb->pquery($sql,array($module,$sourceid,$sourceid));
            }
        }
     }
}


?>